=== debian/changelog ===
ocsigen (1.3.4-2) unstable; urgency=low

  * Fix wrong decoding of + in URL paths (cherry-picked from upstream)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 12 Jul 2011 20:38:51 +0200

ocsigen (1.3.4-1) unstable; urgency=low

  * New upstream release
  * Touch .cmi files after installing the .mli files (Closes: #587300)
  * Bump Standards-Version to 3.9.2 (no changes)

 -- Nicolas Dandrimont <nicolas.dandrimont@crans.org>  Sun, 29 May 2011 13:54:41 +0200

ocsigen (1.3.3-3) unstable; urgency=low

  * Do not try to install native objects on non-natdynlink architectures

 -- Stéphane Glondu <glondu@debian.org>  Fri, 22 Apr 2011 23:47:16 +0200

ocsigen (1.3.3-2) unstable; urgency=low

  * Add missing dependencies to ocsigen: libocsigen-xhtml-ocaml-dev and
    liblwt-ssl-ocaml-dev (Closes: #613372)
  * Do not compile native code version if there is no natdynlink
  * Bump debhelper compat level to 8
  * Bump Standards-Version to 3.9.1

 -- Stéphane Glondu <glondu@debian.org>  Tue, 15 Feb 2011 19:01:11 +0100
