=== debian/control ===
Source: ocsigen
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>,
 Samuel Mimram <smimram@debian.org>,
 Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Build-Depends:
 debhelper (>= 8),
 ocaml-nox (>= 3.11.1-3~),
 camlp4-extra,
 ocaml-findlib (>= 1.2.5),
 liblwt-ssl-ocaml-dev (>= 2.1.1),
 libocamlnet-ocaml-dev (>= 2.2.9-7~),
 libpcre-ocaml-dev (>= 6.0.1-2~),
 libssl-ocaml-dev (>= 0.4.3-3~),
 libgdbm-dev,
 libsqlite3-ocaml-dev (>= 1.5.6-3~),
 libzip-ocaml-dev (>= 1.04-6~),
 libcryptokit-ocaml-dev (>= 1.3-14~),
 libobrowser-ocaml-dev,
 ocamlduce (>= 3.11.1.0-2~),
 dh-ocaml (>= 0.9.5~)
Standards-Version: 3.9.2
Homepage: http://www.ocsigen.org/
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/ocsigen.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/ocsigen.git

Package: ocsigen
Section: httpd
Architecture: any
Depends: adduser, psmisc, procps,
 libocsigen-xhtml-ocaml-dev,
 liblwt-ssl-ocaml-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: httpd, httpd-cgi
Suggests: ocsigen-dev
Breaks: nurpawiki (<< 1.2.3-4~)
Description: web server and programming framework in OCaml
 Ocsigen is a Web server and a programming framework providing a new
 way to create dynamic Web sites. Its goal is to offer an alternative
 to Apache/PHP, based on cutting-edge technologies coming from
 research in programming languages. It has most of the features you
 expect from a Web server (static pages, CGI scripts, etc.) and also
 an innovative module, called Eliom, for generating dynamic Web
 pages. With Eliom, you program in a concise and modular way, with a
 strong type system which helps you to produce valid xhtml. The server
 handles sessions, URLs, and page parameters automatically.
 .
 This package contains the web server itself and shared files.

Package: libocsigen-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: ocsigen-dev
Provides: ocsigen-doc
Replaces: ocsigen-doc (<< 1.2.2)
Breaks: ocsigen-doc (<< 1.2.2)
Description: developer's documentation for Ocsigen
 Ocsigen is a Web server and a programming framework providing a new
 way to create dynamic Web sites.
 .
 This package contains the documentation of all Ocsigen's modules.
 This is developer's documentation, generated by ocamldoc. The
 documentation for the server itself is available online.

Package: ocsigen-dev
Architecture: all
Depends:
 ocsigen (>= ${binary:Version}),
 libocsigen-ocaml-doc (>= ${binary:Version}),
 libocsigen-ocaml-dev (>= ${binary:Version}),
 ocaml-findlib,
 ${misc:Depends}
Description: development metapackage for Ocsigen
 Ocsigen is a Web server and a programming framework providing a new
 way to create dynamic Web sites. Its goal is to offer an alternative
 to Apache/PHP, based on cutting-edge technologies coming from
 research in programming languages. It has most of the features you
 expect from a Web server (static pages, CGI scripts, etc.) and also
 an innovative module, called Eliom, for generating dynamic Web
 pages. With Eliom, you program in a concise and modular way, with a
 strong type system which helps you to produce valid xhtml. The server
 handles sessions, URLs, and page parameters automatically.
 .
 This metapackage brings everything you need to develop Ocsigen
 extensions and Eliom modules: the development librairies, the server
 itself and documentation.

Package: libocsigen-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Replaces:
 ocsigen (<< 1.2.2),
 ocsigen-dev (<< 1.2.2),
 libocsigen-ocaml-dev (<< 1.3.3)
Breaks:
 ocsigen (<< 1.2.2),
 ocsigen-dev (<< 1.2.2),
 libocsigen-ocaml-dev (<< 1.3.3),
 nurpawiki (<< 1.2.3-4~)
Description: runtime librairies for Ocsigen
 Ocsigen is a Web server and a programming framework providing a new
 way to create dynamic Web sites.
 .
 This package contains runtime librairies for Ocsigen.

Package: libocsigen-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 libgdbm-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocsigen-doc
Replaces: ocsigen (<< 1.2.2), ocsigen-dev (<< 1.2.2)
Breaks:
 ocsigen (<< 1.2.2),
 ocsigen-dev (<< 1.2.2),
 nurpawiki (<< 1.2.3-4~)
Description: development librairies for Ocsigen
 Ocsigen is a Web server and a programming framework providing a new
 way to create dynamic Web sites. Its goal is to offer an alternative
 to Apache/PHP, based on cutting-edge technologies coming from
 research in programming languages. It has most of the features you
 expect from a Web server (static pages, CGI scripts, etc.) and also
 an innovative module, called Eliom, for generating dynamic Web
 pages. With Eliom, you program in a concise and modular way, with a
 strong type system which helps you to produce valid xhtml. The server
 handles sessions, URLs, and page parameters automatically.
 .
 This package contains development files for compiling Ocsigen
 extensions and Eliom modules.

Package: libocsigen-xhtml-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib, libocsigen-ocaml-doc
Replaces: libocsigen-ocaml-dev (<< 1.3.0-3~)
Breaks: libocsigen-ocaml-dev (<< 1.3.0-3~)
Description: Ocsigen XHTML generation library
 This package provides the XHTML generation library of Ocsigen, to
 generate statically typed XHTML pages. Typing is achieved with
 polymorphic variants. This library can be used independently of
 Ocsigen. This package contains development files needed to use this
 library alone.
